# Detect mobs in range and create healthbars for them
execute if predicate healthbar:hostile_hb as @s[distance=..75, type=#healthbar:hostile, tag=!Healthbar] run function healthbar:handler/init/new_mob
execute if predicate healthbar:passive_hb as @s[distance=..75, type=#healthbar:passive, tag=!Healthbar] run function healthbar:handler/init/new_mob

# Detect if mobs are out of range and remove their healthbars
execute if predicate healthbar:hostile_hb as @s[distance=76.., type=#healthbar:hostile, tag=Healthbar] run function healthbar:handler/init/out_of_range
execute if predicate healthbar:passive_hb as @s[distance=76.., type=#healthbar:passive, tag=Healthbar] run function healthbar:handler/init/out_of_range

# --------------------------------------------------------------------------------- #

execute if predicate healthbar:hostile_hb as @s[type=#healthbar:hostile, tag=Healthbar, tag=Hit] run return run function healthbar:handler/display/update
execute if predicate healthbar:passive_hb as @s[type=#healthbar:passive, tag=Healthbar, tag=Hit] run return run function healthbar:handler/display/update

# --------------------------------------------------------------------------------- #

execute if predicate healthbar:hostile_hb as @s[distance=..75, type=#healthbar:hostile, tag=Healthbar, predicate=healthbar:hit] run function healthbar:handler/display/update
execute if predicate healthbar:passive_hb as @s[distance=..75, type=#healthbar:passive, tag=Healthbar, predicate=healthbar:hit] run function healthbar:handler/display/update